(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Title:: *)
(*Match Performance*)
(*MM, CS and Combined Score Matrices*)


(* ::Text:: *)
(*Sam Daniel*)
(*October 2006*)


(* ::Subsection:: *)
(*NIST27 Latents and File Prints*)


sps={"b101l9i_10","b102l0i_01","b104l8i_09","b115l8i_09","b119l0i_01","b136l8i_09","b144l3i_04","b145l8i_09","g031l6i_07","g040l6i_07","g051l6i_07","g066l4i_05","u229l2i_03","u230l6i_07","u235l4i_05","u243l8i_09","u285l4i_05"};
fps=getNIST27FilePrintIDs[sps];


getNIST27FilePrintIDs[sps_]:=
Module[{cha,pos},
cha=Characters/@sps;
cha=Map[(pos=Position[#,"l"][[1]][[1]];ReplacePart[#,pos->"t"])&,cha];
StringJoin/@cha]


(* ::Subsection:: *)
(*Match Matrix *)


matchScoreMatrix[alg_,sps_,fps_]:=
Module[{fun,msm,id0,id1,sco},
fun=Switch[alg,
"MM",mmScore,
"CS",csScore];
msm=Map[(id0=#;Print[id0];
Map[(id1=#;sco=fun[id0,id1];Print[id1," ... ",sco];sco)&,fps])&,sps];
Print[TableForm[msm]];
msm]


(* ::Subsection:: *)
(*Match Matrix Display*)


displayMatchMatrix[sm_,matcher_]:=
Module[{dm,rg,mm,po,gm},
dm=Dimensions[sm][[1]];
rg={0,dm+1};
mm=normalizeMatchMatrix[sm];
po=Reverse/@Position[mm,1000];
gm=Graphics[{Red,PointSize[0.05],Map[Point[#]&,po]}];
Show[gm,Frame->True,PlotLabel->matcher,PlotRange->{rg,rg},FrameTicks->{Range[dm],Transpose[{Range[dm],sps}],{},{}}]]


normalizeMatchMatrix[sm_]:=Map[Round[1000#/Max[#]]&,sm];
matchMatrix[sm_]:=Floor[1.005Map[#/Max[#]&,sm]];


(* ::Section:: *)
(*Combined MM and CS Scores*)


combinedMMCS[id0_,ids_]:=
Module[{mmScores,csScores,jds,combScores,mmRank,csRank,combRank,results,table},
{mmScores,csScores}=Transpose[Map[crossSectionCorrelationMeasure[id0,#]&,ids]];
jds=Map[Last[#]&,Reverse[Sort[Transpose[{mmScores,ids}]]]];
mmScores=Reverse@Sort[mmScores];
csScores=reorderScores[csScores,ids,jds];
combScores=mmScores*csScores;
{mmRank,csRank,combRank}=Map[scoreRank[#]&,{mmScores,csScores,combScores}];
mmScores=Round[1000mmScores/Max[mmScores]];
csScores=Round[1000csScores/Max[csScores]];
combScores=Round[1000combScores/Max[combScores]];
results=MapThread[{#1,#2,#3,#4,#5,#6,#7}&,{jds,mmRank,mmScores,csRank,csScores,combRank,combScores}];
table=Map[Prepend[#,""]&,results];
table=Prepend[Rest[table],Prepend[Rest[First[table]],id0]];
Print[TableForm[table,TableSpacing->{1,4},
TableHeadings->{None,{"Latent","File Print","Rank","MM Score","Rank","CS Score","Rank","Combined"}},TableAlignments->Right]]]

reorderScores[scores_,ids_,jds_]:=
Module[{i,c,n},
Map[Last[#]&,Sort@Map[({i,c}=#;n=Position[jds,i][[1]][[1]];{n,c})&,Transpose[{ids,scores}]]]]

scoreRank[s_]:=Map[Position[Reverse@Sort[s],#][[1]][[1]]&,s]


(* ::Section:: *)
(*Runs*)


(* ::Subsection::Closed:: *)
(*Individual Score Matrix Rows*)


(* ::Input::Closed:: *)
(*Timing[*)
(*id0=sps[[1]];*)
(*ids=fps;*)
(*combinedMMCS[id0,ids]]*)


(* ::Input::Closed:: *)
(*Timing[*)
(*id0=sps[[2]];*)
(*ids=fps;*)
(*combinedMMCS[id0,ids]]*)


(* ::Input::Closed:: *)
(*Timing[*)
(*id0=sps[[3]];*)
(*ids=fps;*)
(*combinedMMCS[id0,ids]]*)


(* ::Input::Closed:: *)
(*Timing[*)
(*id0=sps[[4]];*)
(*ids=fps;*)
(*combinedMMCS[id0,ids]]*)


(* ::Input::Closed:: *)
(*Timing[*)
(*id0=sps[[5]];*)
(*ids=fps;*)
(*combinedMMCS[id0,ids]]*)


(* ::Input::Closed:: *)
(*Timing[*)
(*id0=sps[[6]];*)
(*ids=fps;*)
(*combinedMMCS[id0,ids]]*)


(* ::Input::Closed:: *)
(*Timing[*)
(*id0=sps[[7]];*)
(*ids=fps;*)
(*combinedMMCS[id0,ids]]*)


(* ::Input::Closed:: *)
(*Timing[*)
(*id0=sps[[8]];*)
(*ids=fps;*)
(*combinedMMCS[id0,ids]]*)


(* ::Input::Closed:: *)
(*Timing[*)
(*id0=sps[[9]];*)
(*ids=fps;*)
(*combinedMMCS[id0,ids]]*)


(* ::Input::Closed:: *)
(*Timing[*)
(*id0=sps[[10]];*)
(*ids=fps;*)
(*combinedMMCS[id0,ids]]*)


(* ::Input::Closed:: *)
(*Timing[*)
(*id0=sps[[11]];*)
(*ids=fps;*)
(*combinedMMCS[id0,ids]]*)


(* ::Input::Closed:: *)
(*Timing[*)
(*id0=sps[[12]];*)
(*ids=fps;*)
(*combinedMMCS[id0,ids]]*)


(* ::Input::Closed:: *)
(*Timing[*)
(*id0=sps[[13]];*)
(*ids=fps;*)
(*combinedMMCS[id0,ids]]*)


(* ::Print:: *)
(*(SequenceForm["u229l2i_03", " ", "b101t9i_10", " ", 2973, " ", 1.2234083404167724`])*)


(* ::Print:: *)
(*(SequenceForm["u229l2i_03", " ", "b102t0i_01", " ", 2918, " ", 1.2633436077841578`])*)


(* ::Print:: *)
(*(SequenceForm["u229l2i_03", " ", "b104t8i_09", " ", 3087, " ", 1.1961123374170544`])*)


(* ::Print:: *)
(*(SequenceForm["u229l2i_03", " ", "b115t8i_09", " ", 3255, " ", 1.0238946018572987`])*)


(* ::Print:: *)
(*(SequenceForm["u229l2i_03", " ", "b119t0i_01", " ", 2422, " ", 1.1283181551754524`])*)


(* ::Print:: *)
(*(SequenceForm["u229l2i_03", " ", "b136t8i_09", " ", 2531, " ", 1.324902446571374])*)


(* ::Print:: *)
(*(SequenceForm["u229l2i_03", " ", "b144t3i_04", " ", 2930, " ", 1.123117066936506])*)


(* ::Print:: *)
(*(SequenceForm["u229l2i_03", " ", "b145t8i_09", " ", 2741, " ", 0.9011435303234623])*)


(* ::Print:: *)
(*(SequenceForm["u229l2i_03", " ", "g031t6i_07", " ", 3094, " ", 1.171015805263897])*)


(* ::Print:: *)
(*(SequenceForm["u229l2i_03", " ", "g040t6i_07", " ", 3078, " ", 1.0840786116453385`])*)


(* ::Print:: *)
(*(SequenceForm["u229l2i_03", " ", "g051t6i_07", " ", 3196, " ", 0.9828051584856223])*)


(* ::Print:: *)
(*(SequenceForm["u229l2i_03", " ", "g066t4i_05", " ", 2788, " ", 0.9605187931231399])*)


(* ::Print:: *)
(*(SequenceForm["u229l2i_03", " ", "u229t2i_03", " ", 3562, " ", 1.06313339656842])*)


(* ::Print:: *)
(*(SequenceForm["u229l2i_03", " ", "u230t6i_07", " ", 3169, " ", 1.0673008303962521`])*)


(* ::Print:: *)
(*(SequenceForm["u229l2i_03", " ", "u235t4i_05", " ", 2913, " ", 1.2224045414144853`])*)


(* ::Print:: *)
(*(SequenceForm["u229l2i_03", " ", "u243t8i_09", " ", 3173, " ", 1.1251390151900995`])*)


(* ::Print:: *)
(*(SequenceForm["u229l2i_03", " ", "u285t4i_05", " ", 3612, " ", 1.1729885847850137`])*)


(* ::Print:: *)
(*\!\(\**)
(*TagBox[*)
(*TagBox[GridBox[{*)
(*{*)
(*TagBox["\<\"Latent\"\>",*)
(*HoldForm], *)
(*TagBox["\<\"File Print\"\>",*)
(*HoldForm], *)
(*TagBox["\<\"Rank\"\>",*)
(*HoldForm], *)
(*TagBox["\<\"MM Score\"\>",*)
(*HoldForm], *)
(*TagBox["\<\"Rank\"\>",*)
(*HoldForm], *)
(*TagBox["\<\"CS Score\"\>",*)
(*HoldForm], *)
(*TagBox["\<\"Rank\"\>",*)
(*HoldForm], *)
(*TagBox["\<\"Combined\"\>",*)
(*HoldForm]},*)
(*{"\<\"u229l2i_03\"\>", "\<\"u285t4i_05\"\>", "1", "1000", "6", "885", "1", "1000"},*)
(*{"\<\"\"\>", "\<\"u229t2i_03\"\>", "2", "986", "13", "802", "2", "894"},*)
(*{"\<\"\"\>", "\<\"b115t8i_09\"\>", "3", "901", "14", "773", "12", "787"},*)
(*{"\<\"\"\>", "\<\"g051t6i_07\"\>", "4", "885", "15", "742", "14", "741"},*)
(*{"\<\"\"\>", "\<\"u243t8i_09\"\>", "5", "878", "9", "849", "7", "843"},*)
(*{"\<\"\"\>", "\<\"u230t6i_07\"\>", "6", "877", "12", "806", "9", "798"},*)
(*{"\<\"\"\>", "\<\"g031t6i_07\"\>", "7", "857", "7", "884", "6", "855"},*)
(*{"\<\"\"\>", "\<\"b104t8i_09\"\>", "8", "855", "5", "903", "3", "871"},*)
(*{"\<\"\"\>", "\<\"g040t6i_07\"\>", "9", "852", "11", "818", "11", "788"},*)
(*{"\<\"\"\>", "\<\"b101t9i_10\"\>", "10", "823", "3", "923", "5", "858"},*)
(*{"\<\"\"\>", "\<\"b144t3i_04\"\>", "11", "811", "10", "848", "13", "777"},*)
(*{"\<\"\"\>", "\<\"b102t0i_01\"\>", "12", "808", "2", "954", "4", "870"},*)
(*{"\<\"\"\>", "\<\"u235t4i_05\"\>", "13", "806", "4", "923", "8", "840"},*)
(*{"\<\"\"\>", "\<\"g066t4i_05\"\>", "14", "772", "16", "725", "16", "632"},*)
(*{"\<\"\"\>", "\<\"b145t8i_09\"\>", "15", "759", "17", "680", "17", "583"},*)
(*{"\<\"\"\>", "\<\"b136t8i_09\"\>", "16", "701", "1", "1000", "10", "791"},*)
(*{"\<\"\"\>", "\<\"b119t0i_01\"\>", "17", "671", "8", "852", "15", "645"}*)
(*},*)
(*GridBoxAlignment->{"Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},*)
(*GridBoxDividers->{"Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},*)
(*GridBoxSpacings->{"Columns" -> {Offset[0.27999999999999997`], {Offset[2.8]}, Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {Offset[0.2], {Offset[0.4]}, Offset[0.2]}, "RowsIndexed" -> {}}],*)
(*{None, OutputFormsDump`HeadedColumns}],*)
(*Function[BoxForm`e$, MatrixForm[BoxForm`e$, TableSpacing -> {1, 4}, TableHeadings -> {None, {"Latent", "File Print", "Rank", "MM Score", "Rank", "CS Score", "Rank", "Combined"}}, TableAlignments -> Right]]]\)*)


(* ::Output:: *)
(*{411.863,Null}*)


(* ::Input::Closed:: *)
(*Timing[*)
(*id0=sps[[14]];*)
(*ids=fps;*)
(*combinedMMCS[id0,ids]]*)


(* ::Input::Closed:: *)
(*Timing[*)
(*id0=sps[[15]];*)
(*ids=fps;*)
(*combinedMMCS[id0,ids]]*)


(* ::Input::Closed:: *)
(*Timing[*)
(*id0=sps[[16]];*)
(*ids=fps;*)
(*combinedMMCS[id0,ids]]*)


(* ::Input::Closed:: *)
(*Timing[*)
(*id0=sps[[17]];*)
(*ids=fps;*)
(*combinedMMCS[id0,ids]]*)


(* ::Subsection::Closed:: *)
(*MM Run*)


(* ::Input::Closed:: *)
(*matchScoreMatrix["MM",sps,fps]*)


mmScoreMatrix=
{{3554,2277,2610,2659,2100,2192,2887,2268,2596,2356,2516,2281,2401,2789,2038,2684,2070},{2720,5215,3440,3069,3412,2969,3250,2723,3443,2912,2337,3206,2245,3046,2865,2350,2984},{1781,2426,2959,1968,2084,1927,2073,1852,2266,3089,2493,2596,2067,2240,1701,2493,2090},{2263,3205,2424,3262,2618,2374,2272,2153,2581,2664,2561,2912,2640,2896,2839,2419,2463},{2141,2530,2316,2905,3305,2102,2664,2541,2427,2548,2888,2143,2000,2822,2516,2725,2828},{2721,2888,2653,3067,2859,2860,3189,2898,3350,2879,2698,2577,3736,3607,3209,2539,2631},{2247,2424,2547,2300,2701,2004,5488,2092,2762,2134,2602,2196,2807,2544,2738,2380,1923},{2966,3768,2971,3012,2656,3305,2656,5529,3532,2983,2991,2683,3334,3479,2857,2807,3275},{4200,5769,4670,4661,4284,4417,4007,4119,7922,4144,4373,3868,3650,5503,2994,4253,3402},{3779,3683,3207,3686,2775,2958,3060,3348,3629,8685,3908,3447,2334,4158,2502,3309,2868},{3659,3982,4223,4470,3906,4515,4728,4100,4771,3751,10060,3662,5029,4261,4882,4406,4025},{2206,2251,2469,2388,2187,1949,2356,1752,2266,2125,2309,3750,1914,2226,2452,2605,2343},{2973,2918,3087,3255,2422,2531,2930,2741,3094,3078,3196,2788,3562,3169,2913,3173,3612},{1975,2554,2457,2789,2200,2377,2862,2007,3276,2350,2597,2238,2358,4386,2051,2188,2417},{1507,1726,1877,1600,1773,1457,1568,1342,2260,1364,1870,1685,1916,1779,3032,1464,1753},{1952,1802,1625,1761,1928,1501,1857,1511,1534,1563,1621,1907,2054,1782,1317,1624,1690},{1754,2038,1653,1958,1839,2224,1610,1593,2019,1887,1997,1392,2077,1837,1907,1647,3919}};


(* ::Subsection::Closed:: *)
(*CS Run*)


(* ::Input::Closed:: *)
(*matchScoreMatrix["CS",sps,fps]*)


csScoreMatrix=
{{2.174617914931005`,0.9171612976423278`,1.2073831037754739`,1.533833697906524`,1.2616004411331678`,1.5443065448589757`,1.3400805938760365`,1.3594813178687617`,1.1110243255004273`,1.269640430441822`,1.747585553011405`,1.3726690254581926`,1.136522663117806`,1.3300327112036323`,1.1462455049927074`,1.4829903032542067`,0.8011315243908649`},{1.3569973274950133`,2.4138584375523524`,2.195150376798451`,1.5526511386683268`,1.3481338891764463`,1.4509168811601556`,1.8774979632996043`,2.089284727343454`,1.5439005574436406`,1.8855536862212214`,1.681894142258674`,1.8685661188898552`,1.0288440406157302`,1.1371445523691361`,1.5250512127815896`,1.13232654115072`,1.7612062906134212`},{0.8323267507631587`,1.2889247221091766`,2.3020288114776237`,0.9217243960593616`,0.9076194737956296`,1.0017544046450526`,1.2223834354623218`,0.6694817494920808`,0.9689436501157979`,1.1812980220645188`,1.034095602471217`,1.477055190895239`,0.6149966031635418`,0.8389546582867278`,1.6812992201005579`,1.0343120710596259`,1.2282317841992112`},{1.2448351965185067`,1.1112888848905986`,1.589446757329306`,1.7247430246038622`,0.9808496643594588`,1.1946504602090804`,0.8596057051317959`,0.8064454485491453`,1.40291212373033`,1.387868166048736`,1.5140947054692655`,1.3635593934325365`,1.9271766751481525`,0.9938839339206386`,1.5598049859144463`,1.0354597412881408`,1.7049318237080469`},{0.7701808615969176`,1.398240557825951`,1.2500666400527036`,1.3578169341661712`,1.9841539432486028`,0.9599118338486192`,1.5787668763041993`,1.0983852434584411`,1.2989630472769325`,1.1393049666842394`,1.12197905396916`,1.5210630986301654`,0.9671193152321605`,1.2101879410482306`,1.2247233604288854`,1.4521801557309937`,1.211338851617798`},{1.2152784106730132`,1.0014443507938129`,1.6480820379864578`,1.109205475765676`,1.0196966723007765`,1.229165257947115`,0.9820742439086976`,1.1100719880441263`,1.0911084480251743`,1.1616526251836767`,1.1701543688890081`,1.2150788868492084`,1.0646611273184101`,1.0383312449514712`,1.246137577310945`,0.9104972578806421`,1.240468116232693`},{1.0923907371732524`,1.180163938897526`,1.360988686880474`,1.3692970681594725`,1.1584270671260937`,1.2660449441533776`,2.5221631729470952`,1.0693427764375671`,1.2360673429891118`,0.8285393571277305`,1.447732702875558`,1.6434367929203049`,1.1443599955567496`,1.245849337900037`,1.4469781317565718`,0.9909504368565931`,0.7825811810123935`},{1.2195656750345103`,1.1974557980094984`,1.486521019217729`,1.1778722725245798`,1.2608608478278494`,1.3095075036064625`,0.8671777234671966`,1.7433564946399953`,1.125514768704402`,1.2146898460299473`,1.2270569335406212`,1.2706731916097047`,0.9584501633431725`,1.228244509182877`,0.9708203558059116`,0.8409542990345581`,1.2072914529840986`},{1.3682239943891563`,1.3066769542493446`,1.472799889116272`,1.2324825842243359`,1.2153096927665503`,1.2210690431968458`,1.408135332446228`,1.3017462934189508`,1.6773248297597263`,1.2806624720703312`,1.2215716015470817`,1.4264955080866544`,1.177215816873562`,1.2353420890895392`,1.2141501045081229`,1.2959782602011163`,1.5795840225516329`},{1.2731446687573063`,1.2392290317298036`,1.1489844256856436`,1.2957889920880448`,1.2335261105752497`,1.1160281342856246`,1.471551489261913`,1.1326001691858083`,1.156761807610528`,2.7596592263455797`,1.2383577373907897`,1.5173305760309737`,0.923786634028429`,1.1509853921204385`,0.9902628792864867`,1.2528929622063651`,0.933577737511179`},{1.3392937021114104`,1.1573049934366628`,1.3352662241661877`,1.456183148809854`,1.0752705149180735`,1.3462985299944652`,1.4101621626654763`,1.0639924697947847`,1.651434592028856`,1.4198688379352984`,2.7487486542598694`,1.2774778561374953`,1.4212609437874424`,1.2753177863012226`,1.3758766292207496`,1.120168742769603`,1.3523814197448232`},{0.6968873041015772`,1.591866124627671`,1.2407755791196493`,1.1752518292416532`,1.0019524553688721`,1.3664489097377335`,1.0373409743719884`,1.0716335493170641`,1.3503097607264611`,1.5219605059103896`,1.2168665826777965`,1.9555059037396685`,0.799111751837568`,0.8266862562460588`,1.125684606982729`,1.4055942855914754`,0.7994411011075385`},{1.2234083404167724`,1.2633436077841578`,1.1961123374170544`,1.0238946018572987`,1.1283181551754524`,1.324902446571374`,1.123117066936506`,0.9011435303234623`,1.171015805263897`,1.0840786116453385`,0.9828051584856223`,0.9605187931231399`,1.06313339656842`,1.0673008303962521`,1.2224045414144853`,1.1251390151900995`,1.1729885847850137`},{1.3147569374362118`,1.4067348228357193`,1.5206424365007762`,1.225457111896124`,1.0695807759495206`,0.7325036207392068`,1.287586553528361`,1.0767961433578468`,1.1034500987913447`,1.3386700379632748`,1.0181258247740705`,1.1389129421751878`,1.22093196697096`,1.5409624696485427`,0.6896731633504921`,1.0890878011404228`,1.1425867892512658`},{0.4480039847688473`,1.1662500252856225`,1.212825476328947`,1.2329295191473673`,0.6699788788249399`,1.0596120432802434`,0.644870148637899`,0.8284321667600599`,1.1258867856575663`,1.2035450102266803`,1.3753264495578235`,1.7506081892709509`,0.8851817853654286`,0.7872967208165418`,1.6024380034768162`,0.34898722162137163`,1.0231759605142743`},{0.716194873386661`,0.55150912099979`,0.4086304743891138`,0.49490728176176324`,0.5868634857101034`,0.6413167114577916`,0.2494882667210867`,0.6160168469606192`,0.4230360479579399`,0.8809954004057579`,0.2240515790513848`,0.6465188360218029`,0.7102183197759143`,0.9287342011091226`,0.5502954201000662`,1.390282913998898`,0.7518454268460799`},{0.7610615762621078`,1.1048701440490085`,0.303916248187223`,1.3995494426562567`,0.3844347395228383`,0.8748368562601119`,0.6713562661608188`,0.8970677356411443`,1.1346098506246847`,1.3240241241970188`,0.8153475936514596`,0.6317288326413993`,1.1174541385317023`,0.4347949674763621`,1.5122805883314618`,0.41317139417835375`,1.5790860573824312`}};


(* ::Subsection:: *)
(*Displayed MM, CS and Combined Match Matrices*)


(* ::Input:: *)
(*Grid[{MapThread[displayMatchMatrix[#1,#2]&,{{mmScoreMatrix,csScoreMatrix,mmScoreMatrix*csScoreMatrix},{"MM","CS","MM \[Cross] CS"}}]}]*)


(* ::Subsection::Closed:: *)
(*Normalized Scores Matrices*)


(* ::Input:: *)
(*normalizeScoreMatrix[mmScoreMatrix]//TableForm*)


(* ::Input:: *)
(*normalizeScoreMatrix[csScoreMatrix]//TableForm*)


(* ::Input:: *)
(*normalizeScoreMatrix[mmScoreMatrixTWO*csScoreMatrix]//TableForm*)
