(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Title:: *)
(*Registration and Minutiae Matching*)
(*Computation and Dynamic Visualization*)


(* ::Text:: *)
(*Sam Daniel*)
(*September 2006*)


(* ::Section:: *)
(*System Parameters*)


imageFormat="pgm";
minQuantum={16,16,\[Pi]/6}//N;
\[Theta]Scan={\[Theta]1,\[Theta]2,d\[Theta]}={-0.5,0.5,0.05};
errorRadius=1.0;
processingStages={"  Registration"," Matching"};


(* ::Section:: *)
(*Registration and Matching*)


(* ::Subsection:: *)
(*rmVisualization*)


rmViz[id0_,id1_]:=rmViz[id0,id1,imageFormat,\[Theta]Scan]
rmViz[id0_,id1_,imageFormat_,\[Theta]Scan_]:=
DynamicModule[{\[Theta],kmx,m0,gp0,dm0,gm0,m1,gp1,dm1,gm1,g0,g1,rng,dat,mxn,mxs,lbr,lbm,sty,g,hm0,g2,g3,g4,st0,lab,txt,h0,h1,h},
\[Theta]=Chop[Range@@\[Theta]Scan];
kmx=Length[\[Theta]];
{m0,gp0,dm0,gm0}=minutiaePrintData[id0,imageFormat,Red];
{m1,gp1,dm1,gm1}=minutiaePrintData[id1,imageFormat,Blue];
{g0,g1}=Map[Show[#,Frame->True]&,{{gp0,gm0},{gp1,gm1}}];
rng=Reverse[Map[{1,#}&,dm1]];
dat=Map[overlayMinutiae[m0,m1,#]&,\[Theta]];
mxn=Max[Length[Union[#[[5]]]]&/@dat];
mxs=Max[First[#]&/@dat];
lbr=Style["\nMAXIMUM REGISTERED MINUTIAE NUMBER = "<>ToString[mxn],
FontFamily->"Courier",FontSize->12,FontWeight->Bold];
lbm=Style["\nMAXIMUM MATCHING SCORE = "<>ToString[mxs],
FontFamily->"Courier",FontSize->12,FontWeight->Bold];
sty={{20,dm1[[1]]-20},{-1,1},TextStyle->{FontFamily->"Courier",FontSize->10,FontWeight->Bold}};
Manipulate[
{hm0,g2,g3,g4,st0,lab}=rmObjects[dat[[k]],\[Theta][[k]],stage,{lbr,lbm}];
txt=Text@@Prepend[sty,st0];
g=Graphics[{g2,g3,g4,txt}];
h=Show[{g0,Graphics[hm0]}];
If[prints,Grid[{{h,Show[g1,g]}}],Show[{gm1,g},PlotLabel->lab,Frame->True,PlotRange->rng]],
{prints,{False,True}},
{{k,1},1,kmx,1},{stage,processingStages}]]


minutiaePrintData[id_,imageFormat_,color_]:=
Module[{min,gpr,dim,gmo},
min=minutiaeData[id,imageFormat];
gpr=graphicsPrint[id,imageFormat];
dim=Dimensions[gpr[[1,1]]];
gmo=Graphics[minutiaeObjects[min,color]];
{min,gpr,dim,gmo}]


rmObjects[dat_,\[Theta]_,stage_,lables_]:=
Module[{sco,m0r,m0m,rm0,am0,am1,tm0,mm0,mm1,pos,a,b,c,d,lab,gos,tos,stg,st0},
{sco,m0r,m0m,rm0,am0,am1,tm0,mm0,mm1}=dat;
pos=Position[processingStages,stage][[1]][[1]];
{a,b,c,d,lab}=If[pos==1,{m0r,rm0,Union[am0],am1,lables[[1]]},{m0m,tm0,mm0,mm1,lables[[2]]}];
gos=Map[minutiaeObjects@@#&,{{a,Red,0.005},{b,Red},{c,Red,0.005},{d,Blue,0.005}}];
tos=Map[ToString[#]&,{\[Theta],Length[c],sco}];
stg={"Scan Angle = ","\nMM Number  = ","\nMM Score   = "};
st0=StringJoin[MapThread[StringJoin[#1,#2]&,{stg,tos}]];
Join[gos,{st0,lab}]]


(* ::Subsection:: *)
(*rmComputation*)


runMMScores[id0_String,ids_]:=
Module[{m0,is,f,s},
Print[id0];
m0=minutiaeData[id0,imageFormat];
is=Map[({f,s}={#,mmScore[m0,minutiaeData[#,imageFormat],\[Theta]Scan]};
Print[f,"  ",s];{f,s})&,ids];
{id0,Sort[is,#1[[2]]>#2[[2]]&]}]


mmScore[id0_String,id1_String]:=
Module[{m0,m1},
{m0,m1}=Map[minutiaeData[#,imageFormat]&,{id0,id1}];
mmScore[m0,m1,\[Theta]Scan]]


mmScore[m0_,m1_,\[Theta]Scan_]:=
Module[{\[Theta],d},
\[Theta]=Chop[Range@@\[Theta]Scan];
d=Map[overlayMinutiae[m0,m1,#]&,\[Theta]];
Max[First[#]&/@d]]


getIDs[dir_,form_]:=
Module[{myDir,n=Length[ToCharacterCode[form]],fns},
myDir=Directory[];
SetDirectory[dir];
fns=FileNames["*"<>form];
SetDirectory[myDir];
Map[FromCharacterCode[Drop[ToCharacterCode[#],-n]]&,fns]]


(* ::Subsection:: *)
(*overlayMinutiae and matchScore*)


overlayMinutiae[m0_,m1_,\[Theta]_]:=
Module[{m0r,rm0,am0,am1,tv0,tm0,ijs,ers,i,j,m0m,sco,mm0,mm1},
{m0r,rm0,am0,am1,tv0,tm0}=alignMinutiae[m0,m1,\[Theta]];
{ijs,ers}=candidateMatchingIndices[tm0,m1];
{ers,ijs}=Transpose[qualifyPairSets[ijs,ers]];
{i,j}=Transpose[ijs];
m0m=Map[m0[[#]]&,i];
sco=matchScore[ers];
mm0=Map[tm0[[#]]&,i];
mm1=Map[m1[[#]]&,j];
{sco,m0r,m0m,rm0,am0,am1,tm0,mm0,mm1}]

matchScore[e_]:=Module[{n=(Length[e])^0.5},Round[1000n/(1+Mean[e]/n)]]
matchScore[e_]:=Module[{n=(Length[e])^0.5},Round[1000n/(1/n+Mean[e])]]


(* ::Subsection:: *)
(*alignMinutiae*)


alignMinutiae[m0_,m1_,\[Theta]_]:=
Module[{c0,c1,rm0,ijs,is,js,uis,m0r,am0,x,y,\[Alpha],i,am1,set,tv0,s,j,tm0},
{c0,c1}={minCentroid[m0],minCentroid[m1]};
rm0=rotateMinutiae[translateMinutiae[m0,c1-c0],\[Theta],c1];
ijs=candidateRegistrationIndices[rm0,m1];
{is,js}=Transpose[ijs];
uis=Union[is];
m0r=Map[m0[[#]]&,uis];
{am0,am1}={Map[rm0[[#]]&,is],Map[m1[[#]]&,js]};
am0=Map[({x,y,\[Alpha]}=#;{Round[x],Round[y],\[Alpha]})&,am0];
set=Map[(i=#;Select[ijs,#[[1]]==i&])&,uis];
tv0=Round[Mean[Map[(s=#;
  Mean[Map[({i,j}=#;
{1,1,0}(m1[[j]]-rm0[[i]]))&,s]])&,set]]];
tm0=translateMinutiae[rm0,tv0];
tm0=Map[({x,y,\[Alpha]}=#;{Round[x],Round[y],\[Alpha]})&,tm0];
{m0r,rm0,am0,am1,tv0,tm0}]


(* ::Subsection:: *)
(*candidateMatchingIndices*)


candidateMatchingIndices[m0_,m1_]:=
Module[{mds,ers,row,cds,ijs},
mds=Map[#/minQuantum&,minDifs[m0,m1],{2}];
ers=Map[Norm[#]&,mds,{2}];
mds=MapThread[If[#2<=errorRadius,#1,{}]&,{mds,Round@ers},2];
cds=Flatten[Map[(row=#;Select[row,#!={}&])&,mds],1];
ijs=Flatten[Map[Position[mds,#]&,cds],1];
{ijs,ers}]


(* ::Subsection:: *)
(*contendingPairs*)


contendingPairs[{}]:={}
contendingPairs[{{i_,j_},ijs___}]:=
Module[{a,i1,j1},
a=Select[{ijs},#[[1]]==i||#[[2]]==j&];
a=Map[({i1,j1}=#;Select[{ijs},#[[1]]==i1||#[[2]]==j1&])&,a];
a=Union[Prepend[Flatten[a,1],{i,j}]];
Prepend[contendingPairs[Complement[{ijs},Rest@a]],a]]


(* ::Subsection:: *)
(*qualifyPairSets*)


qualifyPairSets[ijs_,ers_]:=
Module[{cps,eps,i,j,nqs},
cps=contendingPairs[ijs];
eps=Map[({i,j}=#;{ers[[i,j]],{i,j}})&,cps,{2}];
eps=Flatten[Map[Sort[#]&,eps],1];
qualifyConnections[eps]]

qualifyConnections[{}]:={}
qualifyConnections[eij_]:=
Module[{s,c,t,d,i1,j1},
s=Sort[eij];
c=numberOfConnections[eij];
t=Select[s,({i1,j1}=s[[1]][[2]];#[[2]][[1]]!=i1&&#[[2]][[2]]!=j1)&];
d=numberOfConnections[t];
If[d<c-1,qualifyConnections[Rest@s],Prepend[qualifyConnections[t],First[s]]]]

numberOfConnections[{}]:=0
numberOfConnections[eij_]:=
Module[{i,j},
{i,j}=Transpose[Last[Transpose[eij]]];
Min[Length/@Union/@{i,j}]]


(* ::Subsubsection::Closed:: *)
(*Obsolete*)


(* ::Input:: *)
(*qualifyPairSets[ijs_,ers_]:=*)
(*Module[{cps,eps,nqs},*)
(*cps=contendingPairs[ijs];*)
(*eps=Map[({i,j}=#;{ers[[i,j]],{i,j}})&,cps,{2}];*)
(*eps=Map[Sort[#]&,eps];*)
(*nqs=Map[If[#=={},0,Floor[Length[Union[Flatten[Map[#[[2]]&,#]]]]/2]]&,eps];*)
(*Flatten[MapThread[qualifyPairs[#1,#2]&,{eps,nqs}],1]]*)


(* ::Input:: *)
(*ClearAll[qualifyPairSets]*)
(*qualifyPairSets[ijs_,ers_]:=*)
(*Module[{cps,eps,nqs},*)
(*cps=contendingPairs[ijs];*)
(*eps=Map[({i,j}=#;{ers[[i,j]],{i,j}})&,cps,{2}];*)
(*eps=Map[Sort[#]&,eps];*)
(*siftEPS[Flatten[eps,1]]]*)
(**)
(*siftEPS[{}]:={}*)
(*siftEPS[{{e1_,p1_}}]:={{e1,p1}}*)
(*siftEPS[{{e1_,p1_},fep___}]:=*)
(*Module[{sep},*)
(*sep=Select[{fep},Intersection[#[[2]],p1]=={}&];*)
(*Prepend[siftEPS[sep],{e1,p1}]]*)


(* ::Input:: *)
(*qualifyPairs[{},nq_]:={}*)
(*qualifyPairs[{{e1_,p1_},eps___},nq_]:=*)
(*Module[{ep1,nq1},*)
(*ep1=Select[{{e1,p1},eps},Intersection[#[[2]],p1]=={}&];*)
(*nq1=If[ep1=={},0,Floor[Length[Union[Flatten[Map[#[[2]]&,ep1]]]]/2]];*)
(*If[nq1==nq-1,Prepend[qualifyPairs[ep1,nq1],{e1,p1}],qualifyPairs[{eps},nq]]]*)


(* ::Subsection:: *)
(*Minutiae Transformations*)


minCentroid[m_]:=Round[Mean[Map[Drop[#,-1]&,m]]]

translateMinutiae[m_,{x_,y_}]:=Map[#+{x,y,0}&,m]
translateMinutiae[m_,{x_,y_,a_}]:=Map[#+{x,y,0}&,m]

rotateMinutiae[m_,\[Theta]_]:=rotateMinutiae[m,\[Theta],{0,0}]
rotateMinutiae[m_,\[Theta]_,c_]:=Map[minRotate[#,\[Theta],c]&,m]

minRotate[{x_,y_,\[Alpha]_},\[Theta]_,c_]:=Append[c+RotationMatrix[\[Theta]].({x,y}-c),Mod[\[Alpha]+\[Theta],2\[Pi]]]


(* ::Subsection:: *)
(*candidateRegistrationIndices and Supporting Functions*)


candidateRegistrationIndices[m0_,m1_]:=
Module[{mds,nds,md,oct,mct,pos,mcd},
mds=Floor[Map[#/minQuantum&,minDifs[m0,m1],{2}]];
mds=Map[selectColinearMins[#]&,mds];
nds=Flatten[Select[Map[(md=#;Select[md,#!={}&])&,mds],#!={}&],1];
oct=occursCount[nds,nds];
mct=Max[oct];
pos=Flatten[Position[oct,mct]][[1]];
mcd=nds[[pos]];
Position[mds,mcd]]


(* ::Subsubsection:: *)
(*Supporting Functions*)


ClearAll[minDif,angleDif,quantizeMin]

minDifs[{},m1_]:={}
minDifs[{m_,m0___},m1_]:=Prepend[minDifs[{m0},m1],Map[minDif[m,#]&,m1]]

minDif[{x0_,y0_,a0_},{x1_,y1_,a1_}]:={x1-x0,y1-y0,angleDif[a0,a1,2\[Pi]]}
angleDif[a0_,a1_,mxa_]:=Min[Abs[{a1-a0,mxa-a1+a0,a1+mxa-a0}]]
quantizeMin[m_,q_]:=m/q

selectColinearMins[{}]:={}
selectColinearMins[{dm_,dms___}]:=Prepend[selectColinearMins[{dms}],If[dm[[3]]==0,dm,{}]]

occursCount[{},mds_]:={}
occursCount[{d1_,ds___},mds_]:=Prepend[occursCount[{ds},mds],Length[Select[mds,#==d1&]]]


(* ::Subsubsection:: *)
(*Some Compiled and More Efficient Supporting Functions*)


ClearAll[minDif,angleDif,quantizeMin,occursCount]

minDif=Compile[{{m0,_Real,1},{m1,_Real,1}},
Module[{x0,y0,a0,x1,y1,a1},
{x0,y0,a0}=m0;
{x1,y1,a1}=m1;
{x1-x0,y1-y0,angleDif[a0,a1,2\[Pi]]}]];

angleDif=Compile[{{a0,_Real},{a1,_Real},{mxa,_Real}},Min[Abs[{a1-a0,mxa-a1+a0,a1+mxa-a0}]]];

quantizeMin=Compile[{{m,_Real,1},{q,_Real,1}},Module[{},Floor[m/q]]];

occursCount[{},{}]:={}
occursCount[{d1_,ds___},mds_]:=
Module[{rds},
rds=Select[mds,#!=d1&];
Prepend[occursCount[{ds},rds],Length[mds]-Length[rds]]]
