(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     50112,       1318]
NotebookOptionsPosition[     46763,       1196]
NotebookOutlinePosition[     48349,       1256]
CellTagsIndexPosition[     48306,       1253]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
 StyleBox["Cross Section",
  FontWeight->"Bold"],
 "\n",
 StyleBox["Gray Scale Cross Section and Related Computations",
  FontSize->16,
  FontWeight->"Bold"]
}], "Title",
 CellChangeTimes->{{3359497257.60821`, 3359497361.33999`}, 
   3359497449.95162`, {3366509870.81328`, 3366509873.16551`}, {
   3366509917.62006`, 3366509926.45961`}, {3366561240.7763`, 
   3366561289.60684`}, {3366561521.34334`, 3366561522.70206`}, {
   3366561555.86175`, 3366561568.13131`}, {3366561608.59614`, 
   3366561609.50824`}, {3368114370.30299`, 3368114452.63753`}, {
   3368217138.39791`, 3368217173.03198`}, {3368388447.21842`, 
   3368388518.02902`}, {3368907325.41142`, 3368907353.86751`}},
 TextAlignment->Center,
 TextJustification->0],

Cell["\<\
Sam Daniel
September 2006\
\>", "Text",
 CellChangeTimes->{{3359497205.94833`, 3359497210.41449`}, {3366509885.75482`,
   3366509890.72959`}},
 TextAlignment->Center,
 TextJustification->0],

Cell[CellGroupData[{

Cell["Combined MM and CS Scores", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.3687649017665*^9, 3.36876493392716*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"combinedMMCS", "[", 
    RowBox[{"id0_", ",", "ids_"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "mmScores", ",", "csScores", ",", "jds", ",", "combScores", ",", 
       "mmRank", ",", "csRank", ",", "combRank", ",", "results", ",", 
       "table"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"mmScores", ",", "csScores"}], "}"}], "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"crossSectionCorrelationMeasure", "[", 
            RowBox[{"id0", ",", "#"}], "]"}], "&"}], ",", "ids"}], "]"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"jds", "=", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Last", "[", "#", "]"}], "&"}], ",", 
         RowBox[{"Reverse", "[", 
          RowBox[{"Sort", "[", 
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"mmScores", ",", "ids"}], "}"}], "]"}], "]"}], "]"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"mmScores", "=", 
       RowBox[{"Reverse", "@", 
        RowBox[{"Sort", "[", "mmScores", "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"csScores", "=", 
       RowBox[{"reorderScores", "[", 
        RowBox[{"csScores", ",", "ids", ",", "jds"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"combScores", "=", 
       RowBox[{"mmScores", "*", "csScores"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"mmRank", ",", "csRank", ",", "combRank"}], "}"}], "=", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"scoreRank", "[", "#", "]"}], "&"}], ",", 
         RowBox[{"{", 
          RowBox[{"mmScores", ",", "csScores", ",", "combScores"}], "}"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"mmScores", "=", 
       RowBox[{"Round", "[", 
        RowBox[{"1000", 
         RowBox[{"mmScores", "/", 
          RowBox[{"Max", "[", "mmScores", "]"}]}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"csScores", "=", 
       RowBox[{"Round", "[", 
        RowBox[{"1000", 
         RowBox[{"csScores", "/", 
          RowBox[{"Max", "[", "csScores", "]"}]}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"combScores", "=", 
       RowBox[{"Round", "[", 
        RowBox[{"1000", 
         RowBox[{"combScores", "/", 
          RowBox[{"Max", "[", "combScores", "]"}]}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"results", "=", 
       RowBox[{"MapThread", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "#1", ",", "#2", ",", "#3", ",", "#4", ",", "#5", ",", "#6", ",", 
            "#7"}], "}"}], "&"}], ",", 
         RowBox[{"{", 
          RowBox[{
          "jds", ",", "mmRank", ",", "mmScores", ",", "csRank", ",", 
           "csScores", ",", "combRank", ",", "combScores"}], "}"}]}], "]"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"table", "=", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Prepend", "[", 
           RowBox[{"#", ",", "\"\<\>\""}], "]"}], "&"}], ",", "results"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"table", "=", 
       RowBox[{"Prepend", "[", 
        RowBox[{
         RowBox[{"Rest", "[", "table", "]"}], ",", 
         RowBox[{"Prepend", "[", 
          RowBox[{
           RowBox[{"Rest", "[", 
            RowBox[{"First", "[", "table", "]"}], "]"}], ",", "id0"}], 
          "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"TableForm", "[", 
        RowBox[{"table", ",", 
         RowBox[{"TableSpacing", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "4"}], "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"TableHeadings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"None", ",", 
            RowBox[{"{", 
             RowBox[{
             "\"\<Latent\>\"", ",", "\"\<File Print\>\"", ",", "\"\<Rank\>\"",
               ",", "\"\<MM Score\>\"", ",", "\"\<Rank\>\"", ",", 
              "\"\<CS Score\>\"", ",", "\"\<Rank\>\"", ",", 
              "\"\<Combined\>\""}], "}"}]}], "}"}]}], ",", 
         RowBox[{"TableAlignments", "\[Rule]", "Right"}]}], "]"}], "]"}]}]}], 
    "]"}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"reorderScores", "[", 
    RowBox[{"scores_", ",", "ids_", ",", "jds_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"i", ",", "c", ",", "n"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Last", "[", "#", "]"}], "&"}], ",", 
       RowBox[{"Sort", "@", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"i", ",", "c"}], "}"}], "=", "#"}], ";", 
             RowBox[{"n", "=", 
              RowBox[{
               RowBox[{
                RowBox[{"Position", "[", 
                 RowBox[{"jds", ",", "i"}], "]"}], "\[LeftDoubleBracket]", 
                "1", "\[RightDoubleBracket]"}], "\[LeftDoubleBracket]", "1", 
               "\[RightDoubleBracket]"}]}], ";", 
             RowBox[{"{", 
              RowBox[{"n", ",", "c"}], "}"}]}], ")"}], "&"}], ",", 
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"ids", ",", "scores"}], "}"}], "]"}]}], "]"}]}]}], 
      "]"}]}], "]"}]}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"scoreRank", "[", "s_", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"Reverse", "@", 
          RowBox[{"Sort", "[", "s", "]"}]}], ",", "#"}], "]"}], 
       "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
      "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], "&"}], ",", 
    "s"}], "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell["Obsolete", "Subsubsection",
 CellChangeTimes->{{3.370206468722334*^9, 3.370206470902585*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"combinedMMCS", "[", 
   RowBox[{"id0_", ",", "ids_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "mmScores", ",", "csScores", ",", "combScores", ",", "results", ",", 
      "table"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"mmScores", ",", "csScores"}], "}"}], "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"crossSectionCorrelationMeasure", "[", 
           RowBox[{"id0", ",", "#"}], "]"}], "&"}], ",", "ids"}], "]"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"csScores", "=", 
      RowBox[{"csScores", "/", 
       RowBox[{"Max", "[", "csScores", "]"}]}]}], ";", "\[IndentingNewLine]", 
     
     RowBox[{"combScores", "=", 
      RowBox[{"Round", "[", 
       RowBox[{"mmScores", "*", "csScores"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"results", "=", 
      RowBox[{"MapThread", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"#1", ",", "#2", ",", "#3", ",", "#4"}], "}"}], "&"}], ",", 
        
        RowBox[{"{", 
         RowBox[{"ids", ",", "mmScores", ",", "csScores", ",", "combScores"}],
          "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"table", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Prepend", "[", 
          RowBox[{"#", ",", "\"\<\>\""}], "]"}], "&"}], ",", "results"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"table", "=", 
      RowBox[{"Prepend", "[", 
       RowBox[{
        RowBox[{"Rest", "[", "table", "]"}], ",", 
        RowBox[{"Prepend", "[", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"First", "[", "table", "]"}], "]"}], ",", "id0"}], "]"}]}],
        "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"TableForm", "[", 
       RowBox[{"table", ",", 
        RowBox[{"TableSpacing", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "4"}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"TableHeadings", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"None", ",", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Latent\>\"", ",", "\"\<File Print\>\"", ",", 
             "\"\<MM Score\>\"", ",", "\"\<CS Score\>\"", ",", 
             "\"\<Combined\>\""}], "}"}]}], "}"}]}]}], "]"}], "]"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.36876516255233*^9, 3.36876520151277*^9}, {
  3.36876528315539*^9, 3.36876557948994*^9}, {3.36876561192105*^9, 
  3.368766015407*^9}, {3.36876622717821*^9, 3.36876624719132*^9}, {
  3.36876649839744*^9, 3.36876650394102*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Designation and Display", "Section",
 CellChangeTimes->{{3368058789.50767`, 3368058803.54119`}, {3368059111.22117`,
   3368059121.28001`}, {3368218043.38934`, 3368218059.43725`}, {
  3368388529.69978`, 3368388550.94574`}, {3368401170.93879`, 
  3368401176.01184`}}],

Cell[CellGroupData[{

Cell["Using Dynamic Module for Designating Line Segment", "Subsection",
 CellChangeTimes->{{3368218102.64297`, 3368218109.369`}, {3368559953.67204`, 
  3368559960.61975`}, {3368743428.80006`, 3368743446.85788`}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"insertSegment", "[", 
    RowBox[{"id_", ",", "color_"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"DynamicModule", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"g1", ",", "g2", ",", "g", ",", "r", ",", "c", ",", 
       RowBox[{"pts", "=", 
        RowBox[{"{", "}"}]}], ",", "a", ",", "b", ",", "h"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"g1", "=", 
       RowBox[{"graphicsPrint", "[", 
        RowBox[{"id", ",", "imageFormat"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"g2", "=", 
       RowBox[{"graphicsMinutiae", "[", 
        RowBox[{"id", ",", "imageFormat", ",", "Yellow", ",", "0.003"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"g", "=", 
       RowBox[{"Show", "[", 
        RowBox[{"{", 
         RowBox[{"g1", ",", "g2"}], "}"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r", ",", "c"}], "}"}], "=", 
       RowBox[{"Dimensions", "[", 
        RowBox[{"g1", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Dynamic", "[", 
       RowBox[{"Grid", "[", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"EventHandler", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"qts", "=", "pts"}], "]"}], ";", "\[IndentingNewLine]",
               
              RowBox[{"pts", "=", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Length", "[", "pts", "]"}], "<", "3"}], ",", "pts",
                  ",", 
                 RowBox[{"Take", "[", 
                  RowBox[{"pts", ",", 
                   RowBox[{"-", "1"}]}], "]"}]}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"a", "=", 
               RowBox[{"Map", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Point", "[", "#", "]"}], "&"}], ",", "pts"}], 
                "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"b", "=", 
               RowBox[{"Line", "[", "pts", "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"h", "=", 
               RowBox[{"Graphics", "[", 
                RowBox[{"{", 
                 RowBox[{"color", ",", "a", ",", "b"}], "}"}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"Show", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"g", ",", "h"}], "}"}], ",", 
                RowBox[{"PlotRange", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "c"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", "r"}], "}"}]}], "}"}]}], ",", 
                RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]}], ",", 
             RowBox[{"\"\<MouseDown\>\"", "\[RuleDelayed]", 
              RowBox[{"(", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"pts", ",", 
                 RowBox[{"Round", "@", 
                  RowBox[{"MousePosition", "[", "\"\<Graphics\>\"", "]"}]}]}],
                 "]"}], ")"}]}]}], "]"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Round", "[", "pts", "]"}], "}"}]}], "}"}], "]"}], 
       "]"}]}]}], "]"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"showCSP", "[", 
   RowBox[{"par_", ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", 
  RowBox[{"{", "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"showCSP", "[", 
   RowBox[{"par_", ",", 
    RowBox[{"{", "p1_", "}"}]}], "]"}], ":=", 
  RowBox[{"{", "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"showCSP", "[", 
   RowBox[{"par_", ",", 
    RowBox[{"{", 
     RowBox[{"p1_", ",", "p2_"}], "}"}]}], "]"}], ":=", "\[IndentingNewLine]",
   
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "csp", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"csp", "=", 
      RowBox[{"crossSectionPrint", "[", 
       RowBox[{"par", ",", "p1", ",", "p2"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"csp", ",", 
       RowBox[{"Filling", "\[Rule]", "Axis"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"Axes", "\[Rule]", "False"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"AspectRatio", "\[Rule]", "0.5"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "380"}]}], "]"}]}]}], 
   "]"}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.3680568779186*^9, 3.36805691913652*^9}, 
   3.36805711800531*^9, {3.36805718777089*^9, 3.36805719157477*^9}, {
   3.36805730920412*^9, 3.36805733618909*^9}, {3.36805737087754*^9, 
   3.36805740869439*^9}, 3.36805747221682*^9, {3.36805759509526*^9, 
   3.36805760043014*^9}, {3.36805768089547*^9, 3.36805777308694*^9}, {
   3.36805784310757*^9, 3.36805786438015*^9}, {3.36805792963416*^9, 
   3.368057989623*^9}, {3.36805826856696*^9, 3.36805827068938*^9}, {
   3.36805842934332*^9, 3.36805848634081*^9}, {3.368058544169*^9, 
   3.36805854603998*^9}, {3.36805857848086*^9, 3.36805859981567*^9}, {
   3.36805901617958*^9, 3.36805901916608*^9}, {3.36805907817088*^9, 
   3.36805908448269*^9}, 3.36806618227851*^9, {3.36806625394146*^9, 
   3.36806628316254*^9}, {3.36806638496412*^9, 3.36806641033769*^9}, {
   3.36806645359776*^9, 3.36806658376585*^9}, {3.36806661544626*^9, 
   3.36806663211764*^9}, {3.36806722753026*^9, 3.368067242231*^9}, {
   3.36806728580743*^9, 3.36806746788221*^9}, 3.36806751920002*^9, {
   3.36806754998371*^9, 3.36806755893231*^9}, {3.36806760843125*^9, 
   3.36806761122402*^9}, {3.36806767047548*^9, 3.36806767872277*^9}, {
   3.36806773757643*^9, 3.3680677467224*^9}, {3.36806783139072*^9, 
   3.36806785537868*^9}, {3.36806792196536*^9, 3.36806803662457*^9}, {
   3.36806806864179*^9, 3.36806806887547*^9}, {3.36806812793736*^9, 
   3.36806812934637*^9}, 3.36806822047843*^9, {3.36806825438901*^9, 
   3.36806833927374*^9}, {3.36806836933986*^9, 3.36806847655326*^9}, {
   3.36806860566445*^9, 3.36806864222416*^9}, {3.36806874216697*^9, 
   3.36806875282441*^9}, {3.36806881394259*^9, 3.36806888843756*^9}, {
   3.36806893833991*^9, 3.36806895086301*^9}, {3.3680689917018*^9, 
   3.36806900317395*^9}, {3.3680691242502*^9, 3.36806912703942*^9}, {
   3.36811482958591*^9, 3.36811485752233*^9}, {3.36812012310936*^9, 
   3.36812030939127*^9}, {3.36812041920089*^9, 3.36812045386921*^9}, {
   3.36812048930539*^9, 3.36812049196047*^9}, {3.3681206195582*^9, 
   3.36812067867531*^9}, {3.36812078729945*^9, 3.36812081560721*^9}, {
   3.36812130759117*^9, 3.36812131132981*^9}, {3.36812141321882*^9, 
   3.36812144860659*^9}, 3.36812152462373*^9, {3.36812274408096*^9, 
   3.3681227729129*^9}, {3.36812291304947*^9, 3.36812297195301*^9}, {
   3.36812308583574*^9, 3.3681231199652*^9}, {3.36821814396549*^9, 
   3.36821816328017*^9}, {3.36837652138646*^9, 3.36837653827601*^9}, {
   3.36837679621765*^9, 3.36837685037851*^9}, {3.36837696302634*^9, 
   3.36837697975964*^9}, {3.36837703412193*^9, 3.36837705111805*^9}, {
   3.36837708259945*^9, 3.36837711461925*^9}, {3.3683771554286*^9, 
   3.3683772261155*^9}, {3.36837734828018*^9, 3.36837748263709*^9}, 
   3.36837755355497*^9, 3.36837758453668*^9, {3.36837762923634*^9, 
   3.36837768238704*^9}, {3.36837780125622*^9, 3.36837780687355*^9}, 
   3.36837857356636*^9, {3.36838546036439*^9, 3.36838553165413*^9}, {
   3.36838573388256*^9, 3.36838573895396*^9}, {3.36838695342788*^9, 
   3.36838695490152*^9}, {3.36838722037402*^9, 3.3683872242467*^9}, {
   3.36838752562375*^9, 3.36838764489867*^9}, {3.36838770105849*^9, 
   3.36838773135255*^9}, 3.36846185031723*^9, {3.36846238092892*^9, 
   3.3684623951667*^9}, {3.36874286635289*^9, 3.36874292494966*^9}, {
   3.36874413816044*^9, 3.36874417826519*^9}, {3.36890796237197*^9, 
   3.36890809193115*^9}, {3.370136019422647*^9, 3.370136030341833*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Using Manipulate to Display Segment Cross Section", "Subsection",
 CellChangeTimes->{{3368218102.64297`, 3368218109.369`}, {3368462475.30473`, 
  3368462478.37679`}, {3368559964.43311`, 3368559994.87204`}, {
  3368560035.042`, 3368560055.61415`}, {3368743410.93933`, 
  3368743412.92182`}, {3368743459.15621`, 3368743481.34629`}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"cspViz", "[", 
   RowBox[{"id_", ",", "qts_", ",", "n1_", ",", "n2_"}], "]"}], ":=", 
  RowBox[{"cspViz", "[", 
   RowBox[{"id", ",", "qts", ",", "n1", ",", "n2", ",", "imageFormat"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"cspViz", "[", 
    RowBox[{"id_", ",", "qts_", ",", "n1_", ",", "n2_", ",", "imageFormat_"}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"DynamicModule", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "gpr", ",", "par", ",", "i1", ",", "j1", ",", "i2", ",", "j2", ",", 
       "sar", ",", "gsa", ",", "org", ",", "gsg", ",", "gcs"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"gpr", "=", 
       RowBox[{"graphicsPrint", "[", 
        RowBox[{"id", ",", "imageFormat"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"par", "=", 
       RowBox[{"N", "[", 
        RowBox[{"gpr", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"i1", ",", "j1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i2", ",", "j2"}], "}"}]}], "}"}], "=", "qts"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"sar", "=", 
       RowBox[{"Take", "[", 
        RowBox[{"par", ",", 
         RowBox[{"Sort", "@", 
          RowBox[{"{", 
           RowBox[{"j1", ",", "j2"}], "}"}]}], ",", 
         RowBox[{"Sort", "@", 
          RowBox[{"{", 
           RowBox[{"i1", ",", "i2"}], "}"}]}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"gsa", "=", 
       RowBox[{"graphicsPixelArray", "[", "sar", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"org", "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Min", "[", 
           RowBox[{"i1", ",", "i2"}], "]"}], ",", 
          RowBox[{"Min", "[", 
           RowBox[{"j1", ",", "j2"}], "]"}]}], "}"}], "-", "0.5"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"gsg", "=", 
       RowBox[{"Graphics", "[", 
        RowBox[{"{", 
         RowBox[{"Red", ",", 
          RowBox[{"Line", "[", 
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "-", "org"}], "&"}], ",", "qts"}], "]"}], "]"}]}], 
         "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"Show", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"gsa", ",", "gsg"}], "}"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"gcs", "=", 
       RowBox[{"getGCSs", "[", 
        RowBox[{"par", ",", "qts", ",", "n1", ",", "n2"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"gcs", "\[LeftDoubleBracket]", 
         RowBox[{
          RowBox[{"k1", "+", "1"}], ",", 
          RowBox[{"k2", "+", "1"}]}], "\[RightDoubleBracket]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"k1", ",", "0"}], "}"}], ",", "0", ",", "n1", ",", "1"}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"k2", ",", "0"}], "}"}], ",", "0", ",", "n2", ",", "5"}], 
         "}"}]}], "]"}]}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"getGCSs", "[", 
   RowBox[{"par_", ",", "qts_", ",", "n1_", ",", "n2_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ijs", ",", "i", ",", "j", ",", "paf"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ijs", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"i", ",", "j"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "n1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "0", ",", "n2"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"i", ",", "j"}], "}"}], "=", "#"}], ";", 
          RowBox[{"paf", "=", 
           RowBox[{"uniformBandPassPixelArray", "[", 
            RowBox[{"i", ",", "j", ",", "par"}], "]"}]}], ";", 
          RowBox[{"showCSP", "[", 
           RowBox[{"paf", ",", "qts"}], "]"}]}], ")"}], "&"}], ",", "ijs", 
       ",", 
       RowBox[{"{", "2", "}"}]}], "]"}]}]}], "]"}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.36845856355691*^9, 3.3684585682518*^9}, {
   3.36845863674426*^9, 3.36845895363997*^9}, {3.36845900811445*^9, 
   3.36845909417073*^9}, {3.36845912887513*^9, 3.36845916899995*^9}, {
   3.36845920876988*^9, 3.36845936450061*^9}, {3.3684595999466*^9, 
   3.36845962642095*^9}, {3.36845974969411*^9, 3.36845975509201*^9}, {
   3.36845994265938*^9, 3.36845996834448*^9}, {3.3684625100964*^9, 
   3.36846252039043*^9}, {3.3684629790485*^9, 3.36846298333376*^9}, {
   3.36846618958946*^9, 3.36846635484329*^9}, {3.36846647510313*^9, 
   3.36846670924702*^9}, {3.3684669371046*^9, 3.36846696407806*^9}, {
   3.36846699596879*^9, 3.36846700495339*^9}, {3.36848074697514*^9, 
   3.36848075197625*^9}, {3.36848083119307*^9, 3.36848084846692*^9}, {
   3.36873176563425*^9, 3.36873177528058*^9}, {3.36873193470346*^9, 
   3.36873194371377*^9}, {3.36873198191195*^9, 3.36873201143108*^9}, {
   3.3687355234098*^9, 3.36873589788286*^9}, {3.36873593865783*^9, 
   3.36873594185588*^9}, {3.36873598718939*^9, 3.36873599741574*^9}, {
   3.36873603869698*^9, 3.36873606521079*^9}, {3.36873614441979*^9, 
   3.36873631443668*^9}, {3.36873661187574*^9, 3.36873662564477*^9}, {
   3.36873676112976*^9, 3.3687367781399*^9}, 3.36873709176975*^9, {
   3.36873765142086*^9, 3.36873765775721*^9}, 3.36891087134751*^9, 
   3.36891151137917*^9, {3.3696976018522787`*^9, 3.3696976051111383`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Cross Section Correlation Measure", "Section",
 CellChangeTimes->{{3368480399.93704`, 3368480431.49969`}, {3368568506.9383`, 
  3368568517.18477`}, {3368581415.89392`, 3368581435.99101`}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"csScore", "[", 
    RowBox[{"id0_", ",", "id1_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"crossSectionCorrelationMeasure", "[", 
     RowBox[{"id0", ",", "id1"}], "]"}], "\[LeftDoubleBracket]", "2", 
    "\[RightDoubleBracket]"}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"crossSectionCorrelationMeasure", "[", 
   RowBox[{"id0_", ",", "id1_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "pa0", ",", "pa1", ",", "sco", ",", "mm0", ",", "mm1", ",", "sp0", ",", 
      "sp1", ",", "ccs", ",", "pro", ",", "a", ",", "b", ",", "c", ",", "d", 
      ",", "\[Mu]0", ",", "\[Sigma]0", ",", "\[Mu]1", ",", "\[Mu]2", ",", 
      "w0", ",", "n0"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"pa0", "=", 
      RowBox[{"pixelArrayPrint", "[", 
       RowBox[{"id0", ",", "imageFormat"}], "]"}]}], ";", 
     RowBox[{"pa0", "=", 
      RowBox[{"uniformBandPassPixelArray", "[", 
       RowBox[{"1", ",", "5", ",", 
        RowBox[{"pa0", "//", "N"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"pa1", "=", 
      RowBox[{"pixelArrayPrint", "[", 
       RowBox[{"id1", ",", "imageFormat"}], "]"}]}], ";", 
     RowBox[{"pa1", "=", 
      RowBox[{"uniformBandPassPixelArray", "[", 
       RowBox[{"1", ",", "5", ",", 
        RowBox[{"pa1", "//", "N"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"sco", ",", "mm0", ",", "mm1"}], "}"}], "=", 
      RowBox[{"matedMinutiae", "[", 
       RowBox[{"id0", ",", "id1", ",", "imageFormat", ",", "\[Theta]Scan"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"sp0", ",", "sp1"}], "}"}], "=", 
      RowBox[{"mmPairSegments", "[", 
       RowBox[{"mm0", ",", "mm1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"ccs", "=", 
      SuperscriptBox[
       RowBox[{"MapThread", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"segmentPairCorrelationCoefficient", "[", 
           RowBox[{"pa0", ",", "pa1", ",", "#1", ",", "#2"}], "]"}], "&"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"sp0", ",", "sp1"}], "}"}]}], "]"}], "2"]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pro", "=", 
      RowBox[{"MapThread", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"a", ",", "b"}], "}"}], "=", "#1"}], ";", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"c", ",", "d"}], "}"}], "=", "#2"}], ";", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Norm", "[", 
               RowBox[{"a", "-", "b"}], "]"}], 
              RowBox[{"Norm", "[", 
               RowBox[{"c", "-", "d"}], "]"}]}], ")"}], "0.25"]}], ")"}], 
         "&"}], ",", 
        RowBox[{"{", 
         RowBox[{"sp0", ",", "sp1"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ccs", "=", 
      RowBox[{"pro", "*", "ccs"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"\[Mu]0", "=", 
      RowBox[{"Mean", "[", "ccs", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"\[Sigma]0", "=", 
      SuperscriptBox[
       RowBox[{"Mean", "[", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"ccs", "-", "\[Mu]0"}], ")"}], "2"], "]"}], "0.5"]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"n0", "=", 
      RowBox[{"Length", "[", "pro", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"\[Mu]1", "=", 
      RowBox[{"\[Mu]0", "-", 
       RowBox[{"\[Sigma]0", "/", 
        SuperscriptBox["n0", "0.5"]}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"w0", "=", 
      RowBox[{"1", "-", 
       RowBox[{"1", "/", 
        SuperscriptBox["1.414", 
         SuperscriptBox["n0", "0.707"]]}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"\[Mu]2", "=", 
      RowBox[{"w0", "*", "\[Mu]1"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{
      "id0", ",", "\"\< \>\"", ",", "id1", ",", "\"\< \>\"", ",", "sco", ",", 
       "\"\< \>\"", ",", "\[Mu]2"}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"sco", ",", "\[Mu]2"}], "}"}]}]}], "]"}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.370267965061927*^9, 3.370268012371106*^9}, {
  3.370312645587481*^9, 3.370312650476129*^9}}],

Cell[CellGroupData[{

Cell["segmentPairCorrelationCoefficients", "Subsection",
 CellChangeTimes->{{3368765050.91392`, 3368765063.85808`}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"segmentPairCorrelationCoefficient", "[", 
   RowBox[{"pa0_", ",", "pa1_", ",", "s0_", ",", "s1_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"pad", "=", 
       RowBox[{"0", 
        RowBox[{"Range", "[", "16", "]"}]}]}], ",", "cs0", ",", "cs1", ",", 
      "nmx"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"cs0", "=", 
      RowBox[{"crossSectionPrint", "[", 
       RowBox[{"pa0", ",", "s0"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"cs1", "=", 
      RowBox[{"crossSectionPrint", "[", 
       RowBox[{"pa1", ",", "s1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"nmx", "=", 
      RowBox[{"Max", "[", 
       RowBox[{
        RowBox[{"Length", "[", "cs0", "]"}], ",", 
        RowBox[{"Length", "[", "cs1", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"cs0", ",", "cs1"}], "}"}], ",", 
         RowBox[{"{", "}"}]}], "]"}], ",", "0", ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"cs0", "=", 
         RowBox[{
          RowBox[{"linearInterpolation", "[", 
           RowBox[{"cs0", ",", "nmx"}], "]"}], "/", 
          RowBox[{"Norm", "[", "cs0", "]"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"cs1", "=", 
         RowBox[{
          RowBox[{"linearInterpolation", "[", 
           RowBox[{"cs1", ",", "nmx"}], "]"}], "/", 
          RowBox[{"Norm", "[", "cs1", "]"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"cs1", "=", 
         RowBox[{"Join", "[", 
          RowBox[{"pad", ",", "cs1", ",", "pad"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Max", "[", 
         RowBox[{"Abs", "[", 
          RowBox[{"ListCorrelate", "[", 
           RowBox[{"cs0", ",", "cs1"}], "]"}], "]"}], "]"}]}]}], "]"}]}]}], 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.36857223975704*^9, 3.36857234071659*^9}, {
   3.36857251526099*^9, 3.36857252271375*^9}, {3.36857257769312*^9, 
   3.36857266347787*^9}, {3.36857269623046*^9, 3.36857276539671*^9}, {
   3.36857280242523*^9, 3.36857284997872*^9}, {3.36857290625862*^9, 
   3.36857295602739*^9}, {3.36857422026781*^9, 3.36857423677785*^9}, 
   3.36857428936947*^9, 3.36857439189184*^9, {3.36857450101076*^9, 
   3.36857451109871*^9}, {3.36857545569061*^9, 3.36857546236622*^9}, {
   3.36857554326197*^9, 3.36857562040335*^9}, {3.3685756554087*^9, 
   3.36857566794475*^9}, 3.36857572659086*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["mmPairSegments", "Subsection",
 CellChangeTimes->{{3368765081.37867`, 3368765087.13633`}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mmPairSegments", "[", 
   RowBox[{"mm0_", ",", "mm1_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"xy0", ",", "xy1"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"xy0", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Take", "[", 
          RowBox[{"#", ",", "2"}], "]"}], "&"}], ",", "mm0"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"xy1", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Take", "[", 
          RowBox[{"#", ",", "2"}], "]"}], "&"}], ",", "mm1"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"makePairs", "[", "xy0", "]"}], ",", 
       RowBox[{"makePairs", "[", "xy1", "]"}]}], "}"}]}]}], "]"}]}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.36857046588609*^9, 3.36857056880701*^9}, {
  3.36857061591248*^9, 3.36857078466749*^9}, {3.36857120041928*^9, 
  3.36857129246562*^9}, {3.36857170060596*^9, 3.36857170459256*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"makePairs", "[", 
   RowBox[{"{", "x_", "}"}], "]"}], ":=", 
  RowBox[{"{", "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"makePairs", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "xs___"}], "}"}], "]"}], ":=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "#"}], "}"}], "&"}], ",", 
      RowBox[{"{", "xs", "}"}]}], "]"}], ",", 
    RowBox[{"makePairs", "[", 
     RowBox[{"{", "xs", "}"}], "]"}]}], "]"}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.368570789206*^9, 3.36857106667058*^9}, {
  3.3685711292761*^9, 3.36857115874082*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["matedMinutiae", "Subsection",
 CellChangeTimes->{{3368765100.96276`, 3368765105.63981`}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"matedMinutiae", "[", 
   RowBox[{"id0_", ",", "id1_", ",", "imageFormat_", ",", "\[Theta]Scan_"}], 
   "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "m0", ",", "m1", ",", "sco", ",", "m0r", ",", "m0m", ",", "rm0", ",", 
      "am0", ",", "am1", ",", "tm0", ",", "mm0", ",", "mm1"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"m0", "=", 
      RowBox[{"minutiaeData", "[", 
       RowBox[{"id0", ",", "imageFormat"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"m1", "=", 
      RowBox[{"minutiaeData", "[", 
       RowBox[{"id1", ",", "imageFormat"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"matedMinutiae", "[", 
      RowBox[{"m0", ",", "m1", ",", "\[Theta]Scan"}], "]"}]}]}], 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.36856938301863*^9, 3.36856949921667*^9}, {
   3.3685695579431*^9, 3.36856967539773*^9}, {3.36856977717074*^9, 
   3.36856986894646*^9}, {3.36856990951389*^9, 3.36856991409591*^9}, {
   3.36856995327119*^9, 3.36857004241761*^9}, {3.36857017174135*^9, 
   3.36857018176309*^9}, 3.36857155490248*^9, {3.36857196221477*^9, 
   3.3685719756635*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"matedMinutiae", "[", 
   RowBox[{"m0_", ",", "m1_", ",", "\[Theta]Scan_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "sco", ",", "m0r", ",", "m0m", ",", "rm0", ",", "am0", ",", "am1", ",", 
      "tm0", ",", "mm0", ",", "mm1"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "sco", ",", "m0r", ",", "m0m", ",", "rm0", ",", "am0", ",", "am1", ",",
         "tm0", ",", "mm0", ",", "mm1"}], "}"}], "=", "\[IndentingNewLine]", 
      RowBox[{"Last", "[", 
       RowBox[{"Sort", "[", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"overlayMinutiae", "[", 
            RowBox[{"m0", ",", "m1", ",", "#"}], "]"}], "&"}], ",", 
          RowBox[{"Chop", "[", 
           RowBox[{"Range", "@@", "\[Theta]Scan"}], "]"}]}], "]"}], "]"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"sco", ",", "m0m", ",", "mm1"}], "}"}]}]}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.36857184573511*^9, 3.36857190472745*^9}, 
   3.36857194690707*^9, {3.36858161225002*^9, 3.36858161387446*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["linearInterpolation", "Subsection",
 CellChangeTimes->{{3368765118.9447`, 3368765123.8923`}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"linearInterpolation", "[", 
   RowBox[{"x_", ",", "n_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", ",", "r", ",", "f", ",", "c", ",", "s"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"m", "=", 
      RowBox[{"Length", "[", "x", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"m", ">=", "n"}], ",", "x", ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"r", "=", 
         RowBox[{"Range", "[", 
          RowBox[{"1", ",", "m", ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"m", "-", "1"}], ")"}], "/", "n"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"f", "=", 
              RowBox[{"Floor", "[", "#", "]"}]}], ";", 
             RowBox[{"c", "=", 
              RowBox[{"Ceiling", "[", "#", "]"}]}], ";", 
             RowBox[{"s", "=", 
              RowBox[{"#", "-", "f"}]}], ";", 
             RowBox[{
              RowBox[{
               RowBox[{
               "x", "\[LeftDoubleBracket]", "c", "\[RightDoubleBracket]"}], 
               "s"}], "+", 
              RowBox[{
               RowBox[{
               "x", "\[LeftDoubleBracket]", "f", "\[RightDoubleBracket]"}], 
               RowBox[{"(", 
                RowBox[{"1", "-", "s"}], ")"}]}]}]}], ")"}], "&"}], ",", 
          "r"}], "]"}]}]}], "]"}]}]}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.36848480916366*^9, 3.36848503232976*^9}, {
   3.36848507193664*^9, 3.36848512536377*^9}, {3.36848526524513*^9, 
   3.36848531575798*^9}, {3.36848538082604*^9, 3.36848544903667*^9}, {
   3.36848548158947*^9, 3.36848556669729*^9}, {3.36848604745457*^9, 
   3.36848610758518*^9}, {3.36848617240419*^9, 3.36848647684344*^9}, {
   3.36848654632282*^9, 3.36848669776997*^9}, {3.36848681739997*^9, 
   3.36848684952071*^9}, {3.36848796656442*^9, 3.36848805752169*^9}, {
   3.3684886502485*^9, 3.36848866465978*^9}, {3.370309789153986*^9, 
   3.37030978967634*^9}, 3.370309899543515*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["crossSectionCorrelation", "Subsection",
 CellChangeTimes->{{3368766560.67219`, 3368766570.11027`}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"crossSectionCorrelation", "[", 
   RowBox[{"id0_", ",", "id1_", ",", "sg0_", ",", "sg1_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"cs0", ",", "cs1", ",", "nmx", ",", "pad", ",", "cfn"}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"cs0", "=", 
      RowBox[{
       RowBox[{"crossSectionProfile", "[", 
        RowBox[{"id0", ",", "sg0", ",", "1", ",", "5"}], "]"}], "//", 
       "Round"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"cs1", "=", 
      RowBox[{
       RowBox[{"crossSectionProfile", "[", 
        RowBox[{"id1", ",", "sg1", ",", "1", ",", "5"}], "]"}], "//", 
       "Round"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"nmx", "=", 
      RowBox[{"Max", "[", 
       RowBox[{"Length", "/@", 
        RowBox[{"{", 
         RowBox[{"cs0", ",", "cs1"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"cs0", "=", 
      RowBox[{
       RowBox[{"linearInterpolation", "[", 
        RowBox[{"cs0", ",", "nmx"}], "]"}], "//", "Round"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"cs1", "=", 
      RowBox[{
       RowBox[{"linearInterpolation", "[", 
        RowBox[{"cs1", ",", "nmx"}], "]"}], "//", "Round"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pad", "=", 
      RowBox[{"0", 
       RowBox[{"Range", "[", "16", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"cs1", "=", 
      RowBox[{"Join", "[", 
       RowBox[{"pad", ",", "cs1", ",", "pad"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"cfn", "=", 
      RowBox[{
       RowBox[{"ListCorrelate", "[", 
        RowBox[{"cs0", ",", "cs1"}], "]"}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Norm", "[", "cs0", "]"}], 
         RowBox[{"Norm", "[", "cs1", "]"}]}], ")"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"cfn", ",", 
       RowBox[{"Filling", "\[Rule]", "Axis"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"Axes", "\[Rule]", "False"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"AspectRatio", "\[Rule]", "0.5"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "380"}]}], "]"}]}]}], "]"}]}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.36874664680177*^9, 3.36874671354003*^9}, {
   3.36874674710828*^9, 3.36874674980976*^9}, {3.36874679001445*^9, 
   3.36874686427951*^9}, {3.36874691066883*^9, 3.36874726035202*^9}, {
   3.36874729486669*^9, 3.36874732681735*^9}, {3.3687474447249*^9, 
   3.36874749315819*^9}, {3.36874752865044*^9, 3.36874755586569*^9}, {
   3.36874808390422*^9, 3.36874808611357*^9}, {3.36874856868625*^9, 
   3.36874860154954*^9}, {3.36874872792064*^9, 3.36874872996746*^9}, {
   3.36876659080575*^9, 3.36876659114032*^9}, {3.36876665196438*^9, 
   3.36876666426415*^9}, 3.36876676257952*^9, {3.36891142824893*^9, 
   3.36891143001896*^9}, {3.36891282496072*^9, 3.36891291935625*^9}, {
   3.36891297824426*^9, 3.36891300216729*^9}, 3.3689132206606*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["crossSectionProfile", "Subsection",
 CellChangeTimes->{{3.36876656067219*^9, 3.36876657011027*^9}, {
  3.370267301206401*^9, 3.3702673037397203`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"crossSectionProfile", "[", 
   RowBox[{"id_", ",", "sg_", ",", "n1_", ",", "n2_"}], "]"}], ":=", 
  RowBox[{"crossSectionProfile", "[", 
   RowBox[{"id", ",", "sg", ",", "n1", ",", "n2", ",", "False"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"crossSectionProfile", "[", 
   RowBox[{"id_", ",", "sg_", ",", "n1_", ",", "n2_", ",", "graph_"}], "]"}], 
  ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"pa", ",", "cs"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"pa", "=", 
      RowBox[{"pixelArrayPrint", "[", 
       RowBox[{"id", ",", "imageFormat"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pa", "=", 
      RowBox[{"uniformBandPassPixelArray", "[", 
       RowBox[{"n1", ",", "n2", ",", "pa"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"cs", "=", 
      RowBox[{
       RowBox[{"crossSectionPrint", "[", 
        RowBox[{"pa", ",", "sg"}], "]"}], "//", "Round"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{"graph", ",", "\[IndentingNewLine]", 
       RowBox[{"ListPlot", "[", 
        RowBox[{"cs", ",", 
         RowBox[{"Filling", "\[Rule]", "Axis"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"Axes", "\[Rule]", "False"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
         RowBox[{"AspectRatio", "\[Rule]", "0.5"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "380"}]}], "]"}], ",", 
       "\[IndentingNewLine]", "cs"}], "]"}]}]}], "]"}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.36874664680177*^9, 3.36874671354003*^9}, {
   3.36874674710828*^9, 3.36874674980976*^9}, {3.36874679001445*^9, 
   3.36874686427951*^9}, {3.36874691066883*^9, 3.36874726035202*^9}, {
   3.36874729486669*^9, 3.36874732681735*^9}, {3.3687474447249*^9, 
   3.36874749315819*^9}, {3.36874752865044*^9, 3.36874755586569*^9}, {
   3.36874808390422*^9, 3.36874808611357*^9}, {3.36874856868625*^9, 
   3.36874860154954*^9}, {3.36874872792064*^9, 3.36874872996746*^9}, {
   3.36876659080575*^9, 3.36876659114032*^9}, {3.36876665196438*^9, 
   3.36876666426415*^9}, 3.36876676257952*^9, {3.36891142824893*^9, 
   3.36891143001896*^9}, {3.36891166742488*^9, 3.36891182646301*^9}, {
   3.36891194789687*^9, 3.36891207052722*^9}, {3.36891210895816*^9, 
   3.36891211142977*^9}, {3.36891219666377*^9, 3.36891220246252*^9}, {
   3.36891238144759*^9, 3.36891238288464*^9}, {3.36891253171315*^9, 
   3.36891263915661*^9}, {3.36891268095781*^9, 3.36891268721958*^9}, {
   3.36891276384139*^9, 3.36891277360737*^9}, 3.36891317826638*^9, {
   3.36891694636172*^9, 3.36891694991701*^9}}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->{"RulerBar", "EditBar"},
RulerUnits->"Inches",
WindowSize->{1157, 939},
WindowMargins->{{Automatic, 101}, {-19, Automatic}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
PageHeaders->{{
   Cell[
    TextData["Pixel Arrays \[LongDash] Gray Scale Graphics and Data"], 
    "Header"], None, 
   Cell[
    TextData["Daniel"], "Header"]}, {
   Cell[
    TextData["Daniel"], "Header"], None, 
   Cell[
    TextData["Pixel Arrays \[LongDash] Gray Scale Graphics and Data"], 
    "Header"]}},
PageFooters->{{
   Cell[
    TextData[{
      CounterBox["Page"]}], "PageNumber"], 
   Cell[
    TextData[""], "Footer"], 
   Cell[
    TextData[{
      ValueBox["FileName"]}], "Footer"]}, {
   Cell[
    TextData[{
      ValueBox["FileName"]}], "Footer"], 
   Cell[
    TextData[""], "Footer"], 
   Cell[
    TextData[{
      CounterBox["Page"]}], "PageNumber"]}},
PageHeaderLines->False,
PrintingOptions->{"FacingPages"->True,
"FirstPageHeader"->False,
"PaperOrientation"->"Portrait",
"PrintCellBrackets"->False,
"PrintMultipleHorizontalPages"->False,
"PrintRegistrationMarks"->True,
"PrintingMargins"->54},
ShowCellLabel->False,
Magnification->1.25,
GraphicsBoxOptions->{AlignmentPoint->ImageScaled[{0.5, 0.5}]},
GraphicsGridBoxOptions->{GraphicsSpacing->{0.1, 0.1}},
FrontEndVersion->"6.0 for Mac OS X PowerPC (32-bit) (October 11, 2006)",
StyleDefinitions->"MyNewDefault.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 739, 17, 144, "Title"],
Cell[1332, 42, 199, 7, 63, "Text"],
Cell[CellGroupData[{
Cell[1556, 53, 134, 2, 87, "Section",
 InitializationCell->True],
Cell[1693, 57, 6255, 166, 467, "Input"],
Cell[CellGroupData[{
Cell[7973, 227, 99, 1, 43, "Subsubsection"],
Cell[8075, 230, 2791, 73, 201, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[10915, 309, 271, 4, 49, "Section"],
Cell[CellGroupData[{
Cell[11211, 317, 212, 2, 55, "Subsection"],
Cell[11426, 321, 8191, 172, 448, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[19654, 498, 336, 4, 55, "Subsection"],
Cell[19993, 504, 6124, 153, 391, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[26166, 663, 194, 2, 87, "Section"],
Cell[26363, 667, 4499, 114, 477, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[30887, 785, 116, 1, 55, "Subsection"],
Cell[31006, 788, 2613, 62, 201, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[33656, 855, 96, 1, 55, "Subsection"],
Cell[33755, 858, 1112, 31, 106, "Input",
 InitializationCell->True],
Cell[34870, 891, 692, 21, 49, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[35599, 917, 95, 1, 55, "Subsection"],
Cell[35697, 920, 1253, 30, 106, "Input",
 InitializationCell->True],
Cell[36953, 952, 1238, 31, 106, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[38228, 988, 99, 1, 55, "Subsection"],
Cell[38330, 991, 2230, 54, 125, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[40597, 1050, 105, 1, 55, "Subsection"],
Cell[40705, 1053, 3089, 73, 239, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[43831, 1131, 156, 2, 55, "Subsection"],
Cell[43990, 1135, 2733, 56, 201, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
