(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     12014,        353]
NotebookOptionsPosition[      9879,        271]
NotebookOutlinePosition[     11461,        331]
CellTagsIndexPosition[     11418,        328]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
 StyleBox["Minutiae",
  FontWeight->"Bold"],
 "\n",
 StyleBox["Minutiae Data and Graphics",
  FontSize->16,
  FontWeight->"Bold"]
}], "Title",
 CellChangeTimes->{{3359497257.60821, 3359497361.33999}, 3359497449.95162, {
   3366509870.81328, 3366509873.16551}, {3366509917.62006, 3366509926.45961}},
 
 TextAlignment->Center,
 TextJustification->0],

Cell["\<\
Sam Daniel
September 2006\
\>", "Text",
 CellChangeTimes->{{3359497205.94833, 3359497210.41449}, {3366509885.75482, 
  3366509890.72959}},
 TextAlignment->Center,
 TextJustification->0],

Cell[CellGroupData[{

Cell["Minutiae Data", "Section",
 CellChangeTimes->{{3359530989.26593, 3359531000.78687}, 3359578889.294, {
   3359594731.90523, 3359594745.64265}, {3366400223.9178, 3366400285.69786}, {
   3366400331.20341, 3366400404.9943}, {3366400450.20913, 3366400459.40963}, {
   3366510252.5357, 3366510256.89071}}],

Cell[CellGroupData[{

Cell["minutiaeData", "Subsection",
 CellChangeTimes->{{3359531058.20085, 3359531065.13343}, {3366395018.81191, 
  3366395023.49615}, {3366399399.43108, 3366399419.81097}, {3366510309.63111, 
  3366510314.21119}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"minutiaeData", "[", 
    RowBox[{"fingerID_", ",", "imageFormat_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "r", ",", "f", ",", "s", ",", "d", ",", "y", ",", "x", ",", "t"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"r", "=", 
       RowBox[{"First", "@", 
        RowBox[{"Dimensions", "[", 
         RowBox[{"pixelArrayPrint", "[", 
          RowBox[{"fingerID", ",", "imageFormat"}], "]"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"f", "=", 
       RowBox[{"fingerID", "<>", "\"\<.min\>\""}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"s", "=", 
       RowBox[{"OpenRead", "[", "f", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Read", "[", 
       RowBox[{"s", ",", "Number"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"d", "=", 
       RowBox[{"ReadList", "[", 
        RowBox[{"s", ",", 
         RowBox[{"{", 
          RowBox[{"Number", ",", "Number", ",", "Number"}], "}"}]}], "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"d", "=", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"y", ",", "x", ",", "t"}], "}"}], "=", "#"}], ";", 
            RowBox[{"{", 
             RowBox[{"x", ",", 
              RowBox[{"r", "-", "y"}], ",", 
              RowBox[{"tailAngleRadians", "[", "t", "]"}]}], "}"}]}], ")"}], 
          "&"}], ",", "d"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Close", "[", "s", "]"}], ";", "\[IndentingNewLine]", "d"}]}], 
    "]"}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tailAngleRadians", "[", "t_", "]"}], ":=", 
  RowBox[{"tailAngleRadians", "[", 
   RowBox[{"t", ",", "512"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"tailAngleRadians", "[", 
   RowBox[{"t_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"2.0", "t", " ", 
   RowBox[{"\[Pi]", "/", "n"}]}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.36651031863544*^9, 3.3665103542066*^9}, {
  3.36651041539337*^9, 3.36651042815486*^9}, {3.36651100335114*^9, 
  3.36651100398216*^9}, {3.36651104472896*^9, 3.36651111761089*^9}, {
  3.36651169373857*^9, 3.36651177016291*^9}, {3.36651181732149*^9, 
  3.36651183528403*^9}, {3.36651192028401*^9, 3.36651196822706*^9}, {
  3.36651228644915*^9, 3.36651229002066*^9}, {3.36651236113106*^9, 
  3.36651238407173*^9}, {3.36651246002034*^9, 3.36651252317842*^9}, {
  3.36651262528555*^9, 3.36651279563986*^9}, {3.36651284081275*^9, 
  3.36651284304773*^9}, {3.36651288206851*^9, 3.36651288560387*^9}, {
  3.36651293230042*^9, 3.36651296778008*^9}, {3.36651299993223*^9, 
  3.36651301214556*^9}, {3.36651336888546*^9, 3.36651346442325*^9}, {
  3.36656493337237*^9, 3.36656496200432*^9}, {3.370312032684581*^9, 
  3.370312033255403*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Minutiae Graphics", "Section",
 CellChangeTimes->{{3359530989.26593, 3359531000.78687}, 3359578889.294, {
   3359594731.90523, 3359594745.64265}, {3366400223.9178, 3366400285.69786}, {
   3366400331.20341, 3366400404.9943}, {3366400450.20913, 3366400459.40963}, {
   3366510252.5357, 3366510256.89071}, {3366515455.69383, 3366515457.9537}}],

Cell[CellGroupData[{

Cell["graphicsMinutiae", "Subsection",
 CellChangeTimes->{{3359531058.20085, 3359531065.13343}, {3366395018.81191, 
   3366395023.49615}, {3366399399.43108, 3366399419.81097}, {3366510309.63111,
    3366510314.21119}, {3366513680.43167, 3366513686.93998}, 
   3366515480.90666, {3366515557.51954, 3366515559.6417}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"graphicsMinutiae", "[", 
   RowBox[{"fingerID_", ",", "imageFormat_"}], "]"}], ":=", 
  RowBox[{"graphicsMinutiae", "[", 
   RowBox[{"fingerID", ",", "imageFormat", ",", "Black", ",", "0.001"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"graphicsMinutiae", "[", 
   RowBox[{"fingerID_", ",", "imageFormat_", ",", "color_"}], "]"}], ":=", 
  RowBox[{"graphicsMinutiae", "[", 
   RowBox[{"fingerID", ",", "imageFormat", ",", "color", ",", "0.001"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"graphicsMinutiae", "[", 
   RowBox[{"fingerID_", ",", "imageFormat_", ",", "color_", ",", "thk_"}], 
   "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Graphics", "[", 
   RowBox[{"minutiaeObjects", "[", 
    RowBox[{
     RowBox[{"minutiaeData", "[", 
      RowBox[{"fingerID", ",", "imageFormat"}], "]"}], ",", "color", ",", 
     "thk"}], "]"}], "]"}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.36651412986116*^9, 3.36651441653315*^9}, {
   3.36651445267739*^9, 3.36651457508199*^9}, {3.36651464414148*^9, 
   3.3665146466527*^9}, {3.36651492178034*^9, 3.36651492857998*^9}, {
   3.36651510120563*^9, 3.36651510170234*^9}, {3.3665152861186*^9, 
   3.36651528683326*^9}, {3.36651556666836*^9, 3.3665155681558*^9}, {
   3.36651559982198*^9, 3.3665156834026*^9}, {3.36651573344878*^9, 
   3.36651579345542*^9}, {3.36651582547117*^9, 3.3665158458366*^9}, {
   3.36651592974966*^9, 3.36651593070852*^9}, {3.36715222158644*^9, 
   3.36715224190875*^9}, {3.36715230136806*^9, 3.36715242567711*^9}, {
   3.36715339274981*^9, 3.36715341775568*^9}, {3.36883780373951*^9, 
   3.36883786791699*^9}, 3.36883816003018*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["minutiaeObjects", "Subsection",
 CellChangeTimes->{{3359531058.20085, 3359531065.13343}, {3366395018.81191, 
   3366395023.49615}, {3366399399.43108, 3366399419.81097}, {3366510309.63111,
    3366510314.21119}, {3366513680.43167, 3366513686.93998}, 
   3366515480.90666, {3367151629.66103, 3367151634.57447}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"minutiaeObjects", "[", "m_", "]"}], ":=", 
  RowBox[{"minutiaeObjects", "[", 
   RowBox[{"m", ",", "Black", ",", "0.001"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"minutiaeObjects", "[", 
   RowBox[{"m_", ",", "color_"}], "]"}], ":=", 
  RowBox[{"minutiaeObjects", "[", 
   RowBox[{"m", ",", "color", ",", "0.001"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"minutiaeObjects", "[", 
   RowBox[{"m_", ",", "color_", ",", "thk_"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"minObject", "[", 
      RowBox[{"#", ",", "color", ",", "thk"}], "]"}], "&"}], ",", "m"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"minObject", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x_", ",", "y_", ",", "\[Theta]_"}], "}"}], ",", "color_", ",", 
    "thk_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"color", ",", 
    RowBox[{"Thickness", "[", "thk", "]"}], ",", 
    RowBox[{"Circle", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x", ",", "y"}], "}"}], ",", "9"}], "]"}], ",", 
    RowBox[{"Line", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "y"}], "}"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x", ",", "y"}], "}"}], "+", 
          RowBox[{"24", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Cos", "[", "#", "]"}], ",", 
             RowBox[{"Sin", "[", "#", "]"}]}], "}"}]}]}], "&"}], "[", 
        "\[Theta]", "]"}]}], "}"}], "]"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"minObject", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"p1_", ",", "p2_"}], "}"}], ",", "color_", ",", "thk_"}], "]"}], 
  ":=", 
  RowBox[{"minObject", "[", 
   RowBox[{
    RowBox[{"Append", "[", 
     RowBox[{"p1", ",", 
      RowBox[{"N", "[", 
       RowBox[{"ArcTan", "@@", 
        RowBox[{"(", 
         RowBox[{"p2", "-", "p1"}], ")"}]}], "]"}]}], "]"}], ",", "color", 
    ",", "thk"}], "]"}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.3671514961696*^9, 3.36715149783279*^9}, {
   3.367151533241*^9, 3.367151568537*^9}, {3.36715190927692*^9, 
   3.36715201932164*^9}, {3.36715205024404*^9, 3.36715213366976*^9}, {
   3.36803614446219*^9, 3.36803614584855*^9}, 3.36803700314349*^9, {
   3.3680652946016*^9, 3.36806530562899*^9}}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->{"RulerBar", "EditBar"},
RulerUnits->"Inches",
WindowSize->{968, 933},
WindowMargins->{{45, Automatic}, {Automatic, 4}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
PageHeaders->{{
   Cell[
    TextData["Pixel Arrays \[LongDash] Gray Scale Graphics and Data"], 
    "Header"], None, 
   Cell[
    TextData["Daniel"], "Header"]}, {
   Cell[
    TextData["Daniel"], "Header"], None, 
   Cell[
    TextData["Pixel Arrays \[LongDash] Gray Scale Graphics and Data"], 
    "Header"]}},
PageFooters->{{
   Cell[
    TextData[{
      CounterBox["Page"]}], "PageNumber"], 
   Cell[
    TextData[""], "Footer"], 
   Cell[
    TextData[{
      ValueBox["FileName"]}], "Footer"]}, {
   Cell[
    TextData[{
      ValueBox["FileName"]}], "Footer"], 
   Cell[
    TextData[""], "Footer"], 
   Cell[
    TextData[{
      CounterBox["Page"]}], "PageNumber"]}},
PageHeaderLines->False,
PrintingOptions->{"FacingPages"->True,
"FirstPageHeader"->False,
"PaperOrientation"->"Portrait",
"PrintCellBrackets"->False,
"PrintMultipleHorizontalPages"->False,
"PrintRegistrationMarks"->True,
"PrintingMargins"->54},
ShowCellLabel->False,
Magnification->1.25,
GraphicsBoxOptions->{AlignmentPoint->ImageScaled[{0.5, 0.5}]},
GraphicsGridBoxOptions->{GraphicsSpacing->{0.1, 0.1}},
FrontEndVersion->"6.0 for Mac OS X PowerPC (32-bit) (October 11, 2006)",
StyleDefinitions->"MyNewDefault.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 363, 12, 144, "Title"],
Cell[956, 37, 195, 7, 63, "Text"],
Cell[CellGroupData[{
Cell[1176, 48, 305, 4, 87, "Section"],
Cell[CellGroupData[{
Cell[1506, 56, 212, 3, 55, "Subsection"],
Cell[1721, 61, 2950, 70, 258, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4720, 137, 346, 4, 87, "Section"],
Cell[CellGroupData[{
Cell[5091, 145, 315, 4, 55, "Subsection"],
Cell[5409, 151, 1688, 34, 125, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[7134, 190, 315, 4, 55, "Subsection"],
Cell[7452, 196, 2387, 70, 125, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
